(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/overlay'), require('@angular/common'), require('@angular/router'), require('@ng-tangram/components/overlay'), require('rxjs'), require('rxjs/operators'), require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/navigation', ['exports', '@angular/core', '@angular/cdk/overlay', '@angular/common', '@angular/router', '@ng-tangram/components/overlay', 'rxjs', 'rxjs/operators', '@angular/cdk/coercion'], factory) :
    (global = global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.navigation = {}), global.ng.core, global.ng.cdk.overlay, global.ng.common, global.ng.router, global.nt.components.overlay, global.rxjs, global.rxjs.operators, global.ng.cdk.coercion));
}(this, (function (exports, core, overlay, common, router, overlay$1, rxjs, operators, coercion) { 'use strict';

    (function (NtNavUrlTreeStrategy) {
        NtNavUrlTreeStrategy[NtNavUrlTreeStrategy["Integrity"] = 0] = "Integrity";
        NtNavUrlTreeStrategy[NtNavUrlTreeStrategy["OnlyParents"] = 1] = "OnlyParents";
    })(exports.NtNavUrlTreeStrategy || (exports.NtNavUrlTreeStrategy = {}));
    var NT_NAV_CONFIG = new core.InjectionToken('nt-nav-config');

    var RESOLVE_TITLE_PLACEHOLDER = /^resolve::/;
    function resolveTitle(snapshot, title) {
        var _a;
        if (RESOLVE_TITLE_PLACEHOLDER.test(title)) {
            var paths = title.replace(RESOLVE_TITLE_PLACEHOLDER, '').split('.');
            var key = paths.shift();
            try {
                if (key && ((_a = snapshot.data) === null || _a === void 0 ? void 0 : _a.hasOwnProperty(key))) {
                    var data = snapshot.data[key];
                    var path = paths.shift();
                    var result = path ? data[path] : null;
                    while (paths.length > 0 && result instanceof Object) {
                        path = paths.shift();
                        result = path ? result[path] : null;
                    }
                    return result;
                }
                return key || '';
            }
            catch (_b) { }
        }
        return title;
    }

    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var __param = (this && this.__param) || function (paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    };
    var NT_NAV_MENUS = new core.InjectionToken('nt-nav-menus');
    var NtNavigationAdapter = (function () {
        function NtNavigationAdapter(route, router$1, config, menus) {
            var _this = this;
            this.route = route;
            this.router = router$1;
            this.config = config;
            this.destroy = new rxjs.Subject();
            this.menus = new rxjs.BehaviorSubject([]);
            this.activatedUrlTree = new rxjs.BehaviorSubject([]);
            this.activeUrl = new rxjs.BehaviorSubject({});
            this.menus.next(menus);
            router$1.events
                .pipe(operators.takeUntil(this.destroy), operators.filter(function (event) { return event instanceof router.NavigationEnd; }))
                .subscribe(function () { return _this.buildUrlTree(_this.route); });
        }
        NtNavigationAdapter.prototype.ngOnDestroy = function () {
            this.destroy.next();
            this.destroy.complete();
        };
        NtNavigationAdapter.prototype.getRouteMenus = function () {
            return this.menus.asObservable();
        };
        NtNavigationAdapter.prototype.buildUrlTree = function (route) {
            var url = [];
            var tree = [];
            while (route.firstChild) {
                route = route.firstChild;
                var snapshot = route.snapshot;
                if (snapshot.data && snapshot.data.title && snapshot.url.length > 0) {
                    var data = snapshot.data, title = void 0;
                    title = resolveTitle(snapshot, data.title);
                    url = url.concat(snapshot.url.map(function (segment) { return segment.path; }));
                    tree.push({ title: title, url: url, icon: data.icon });
                }
            }
            this.activeUrl.next(tree[tree.length - 1]);
            if (this.config.urlTreeStrategy === exports.NtNavUrlTreeStrategy.OnlyParents) {
                tree.splice(tree.length - 1, 1);
            }
            this.activatedUrlTree.next(tree);
        };
        NtNavigationAdapter.ctorParameters = function () { return [
            { type: router.ActivatedRoute },
            { type: router.Router },
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_NAV_CONFIG,] }] },
            { type: Array, decorators: [{ type: core.Inject, args: [NT_NAV_MENUS,] }] }
        ]; };
        NtNavigationAdapter = __decorate([
            core.Injectable(),
            __param(2, core.Inject(NT_NAV_CONFIG)),
            __param(3, core.Inject(NT_NAV_MENUS))
        ], NtNavigationAdapter);
        return NtNavigationAdapter;
    }());

    var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtNavBreadcrumbsComponent = (function () {
        function NtNavBreadcrumbsComponent(navAdapter) {
            this.navAdapter = navAdapter;
            this.activeUrl$ = this.navAdapter.activeUrl.asObservable();
        }
        NtNavBreadcrumbsComponent.ctorParameters = function () { return [
            { type: NtNavigationAdapter }
        ]; };
        NtNavBreadcrumbsComponent = __decorate$1([
            core.Component({
                selector: 'nt-nav-breadcrumbs',
                template: "<ng-container *ngIf=\"activeUrl$ | async as activeUrl\">\n  <span class=\"nt-nav-activated-icon {{ activeUrl.icon }}\"></span>\n  <span class=\"nt-nav-activated-title\">{{ activeUrl.title }}</span>\n  <ul class=\"nt-nav-breadcrumbs-menu\">\n    <li *ngFor=\"let item of navAdapter.activatedUrlTree | async; let $index = index;\">\n      <a [routerLink]=\"['./'].concat(item.url)\">\n        {{ item.title }}\n      </a>\n    </li>\n  </ul>\n</ng-container>\n",
                encapsulation: core.ViewEncapsulation.None,
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                host: {
                    'class': 'nt-nav-breadcrumbs'
                }
            })
        ], NtNavBreadcrumbsComponent);
        return NtNavBreadcrumbsComponent;
    }());

    var __assign = (this && this.__assign) || function () {
        __assign = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    var NtNavController = (function () {
        function NtNavController(changeDetectorRef, navAdapter) {
            var _this = this;
            this.changeDetectorRef = changeDetectorRef;
            this.navAdapter = navAdapter;
            this.destroy = new rxjs.Subject();
            this.routeMenusUpdate = new rxjs.Subject();
            rxjs.merge(this.routeMenusUpdate, navAdapter.getRouteMenus()).pipe(operators.switchMap(function () { return navAdapter.getRouteMenus(); }), operators.takeUntil(this.destroy)).subscribe(function (menus) {
                _this._routeMenus = _this._filterRouteMenus(menus);
                _this._checkActivatedMenu();
                _this.changeDetectorRef.markForCheck();
            });
            this.navAdapter.activatedUrlTree
                .pipe(operators.takeUntil(this.destroy), operators.filter(function (tree) { return tree.length > 0; }))
                .subscribe(function () {
                _this._checkActivatedMenu();
                _this.changeDetectorRef.markForCheck();
            });
        }
        NtNavController.prototype._checkActivatedMenu = function () {
            var currentTree = this.navAdapter.activatedUrlTree.value;
            if (currentTree.length > 0) {
                var moduleName_1 = currentTree[0].url.join('/');
                var activated = this._routeMenus.find(function (menu) { return menu.path === moduleName_1; });
                activated && (activated.folded = true);
            }
        };
        NtNavController.prototype._filterRouteMenus = function (menus) {
            var _this = this;
            if (typeof this.filter !== 'function') {
                return menus;
            }
            var parents = menus.filter(function (parent) {
                if (parent.children && parent.children.length > 0) {
                    return true;
                }
                else {
                    return _this.filter(parent);
                }
            });
            var value = parents.map(function (parent) {
                var copy = __assign({}, parent);
                if (copy.children) {
                    copy.children = copy.children.filter(function (child) { return _this.filter(child); });
                }
                return copy;
            });
            var result = [];
            value.forEach(function (menuItem) {
                if (!menuItem.children || (menuItem.children && menuItem.children.length > 0)) {
                    result.push(__assign({}, menuItem));
                }
            });
            return result;
        };
        return NtNavController;
    }());

    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtNavSidebarComponent = (function (_super) {
        __extends(NtNavSidebarComponent, _super);
        function NtNavSidebarComponent(changeDetectorRef, navAdapter) {
            var _this = _super.call(this, changeDetectorRef, navAdapter) || this;
            _this._dropdown = false;
            _this._baseUrl = navAdapter.config.baseUrl || './';
            return _this;
        }
        Object.defineProperty(NtNavSidebarComponent.prototype, "dropdown", {
            get: function () { return this._dropdown; },
            set: function (value) {
                this._dropdown = coercion.coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtNavSidebarComponent.prototype, "filter", {
            get: function () { return this._filter; },
            set: function (value) {
                if (value) {
                    this._filter = value;
                    this.routeMenusUpdate.next();
                }
            },
            enumerable: true,
            configurable: true
        });
        NtNavSidebarComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef },
            { type: NtNavigationAdapter }
        ]; };
        __decorate$2([
            core.Input()
        ], NtNavSidebarComponent.prototype, "dropdown", null);
        __decorate$2([
            core.Input()
        ], NtNavSidebarComponent.prototype, "filter", null);
        __decorate$2([
            core.Input()
        ], NtNavSidebarComponent.prototype, "title", void 0);
        __decorate$2([
            core.Input()
        ], NtNavSidebarComponent.prototype, "logo", void 0);
        NtNavSidebarComponent = __decorate$2([
            core.Component({
                selector: 'nt-nav-sidebar',
                template: "\n<!-- <ng-content select=\"nt-nav-sidebar-logo\"></ng-content> -->\n<div class=\"nt-nav-sidebar-brand\">\n  <img class=\"nt-nav-sidebar-logo\" [src]=\"logo\">\n  <span class=\"nt-nav-sidebar-title\" *ngIf=\"!dropdown\">{{ title }}</span>\n</div>\n\n<ul class=\"nt-nav-sidebar-root-menu\">\n  <li *ngFor=\"let parent of _routeMenus\"\n    routerLinkActive=\"active\"\n    [class.folded]=\"parent.folded\"\n    [class.has-children]=\"parent.children\">\n\n    <ng-container *ngIf=\"!dropdown else dropdownMode\">\n      <a *ngIf=\"!parent.children else hasChildrenMenus\" [routerLink]=\"[_baseUrl, parent.path]\">\n        <i [class]=\"parent.data['icon']\"></i>\n        <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n      </a>\n      <ng-template #hasChildrenMenus>\n        <a (click)=\"parent.folded = !parent.folded\">\n          <i [class]=\"parent.data['icon']\"></i>\n          <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n        </a>\n        <ul class=\"nt-nav-sidebar-nested-menu\">\n          <li *ngFor=\"let child of parent.children\" routerLinkActive=\"active\">\n            <a [routerLink]=\"[_baseUrl, parent.path, child.path]\">\n              <span class=\"nt-nav-sidebar-title\">{{ child.data['title'] }}</span>\n            </a>\n          </li>\n        </ul>\n      </ng-template>\n    </ng-container>\n\n    <ng-template #dropdownMode>\n      <ng-container *ngIf=\"!parent.children else hasChildrenMenus\">\n        <a #origin=\"cdkOverlayOrigin\"\n        cdkOverlayOrigin\n        (mouseenter)=\"overlay.markOpen()\"\n        (mouseleave)=\"overlay.markClose()\"\n        [routerLink]=\"[_baseUrl, parent.path]\">\n          <i [class]=\"parent.data['icon']\"></i>\n          <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n\n          <nt-overlay\n            #overlay\n            overlayClass=\"nt-nav-dropdown-overlay\"\n            [origin]=\"origin\"\n            position=\"rightTop\"\n            [arrow]=\"true\"\n            (overlayEnter)=\"overlay.markOpen()\"\n            (overlayLeave)=\"overlay.markClose()\">\n            <div class=\"nt-nav-dropdown-pane\">\n              <div class=\"nt-nav-dropdown-title\">{{ parent.data['title'] }}</div>\n            </div>\n          </nt-overlay>\n        </a>\n      </ng-container>\n      <ng-template #hasChildrenMenus>\n        <a #origin=\"cdkOverlayOrigin\"\n          cdkOverlayOrigin\n          (mouseenter)=\"overlay.markOpen()\"\n          (mouseleave)=\"overlay.markClose()\">\n          <i [class]=\"parent.data['icon']\"></i>\n          <span class=\"nt-nav-sidebar-title\">{{ parent.data['title'] }}</span>\n          <nt-overlay\n            #overlay\n            overlayClass=\"nt-nav-dropdown-overlay\"\n            [origin]=\"origin\"\n            position=\"rightTop\"\n            [arrow]=\"true\"\n            (overlayEnter)=\"overlay.markOpen()\"\n            (overlayLeave)=\"overlay.markClose()\">\n            <div class=\"nt-nav-dropdown-pane\">\n              <div class=\"nt-nav-dropdown-title\">{{ parent.data['title'] }}</div>\n              <ul class=\"nt-nav-dropdown-menu\">\n                <li *ngFor=\"let child of parent.children\" routerLinkActive=\"active\">\n                  <a [routerLink]=\"[_baseUrl, parent.path, child.path]\">\n                    <span>{{ child.data['title'] }}</span>\n                  </a>\n                </li>\n              </ul>\n            </div>\n          </nt-overlay>\n        </a>\n      </ng-template>\n    </ng-template>\n  </li>\n</ul>\n\n",
                encapsulation: core.ViewEncapsulation.None,
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                host: {
                    'class': 'nt-nav-sidebar',
                    '[class.dropdown-mode]': 'dropdown'
                }
            })
        ], NtNavSidebarComponent);
        return NtNavSidebarComponent;
    }(NtNavController));

    var __extends$1 = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var __decorate$3 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtNavTopbarComponent = (function (_super) {
        __extends$1(NtNavTopbarComponent, _super);
        function NtNavTopbarComponent(changeDetectorRef, navAdapter) {
            var _this = _super.call(this, changeDetectorRef, navAdapter) || this;
            _this._baseUrl = navAdapter.config.baseUrl || './';
            return _this;
        }
        Object.defineProperty(NtNavTopbarComponent.prototype, "filter", {
            get: function () { return this._filter; },
            set: function (value) {
                if (value) {
                    this._filter = value;
                    this.routeMenusUpdate.next();
                }
            },
            enumerable: true,
            configurable: true
        });
        NtNavTopbarComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef },
            { type: NtNavigationAdapter }
        ]; };
        __decorate$3([
            core.Input()
        ], NtNavTopbarComponent.prototype, "filter", null);
        NtNavTopbarComponent = __decorate$3([
            core.Component({
                selector: 'nt-nav-topbar',
                template: "<ul class=\"nt-nav-topbar-menu\">\n  <li *ngFor=\"let parent of _routeMenus\" routerLinkActive=\"active\" class=\"nt-nav-topbar-menu-item\">\n    <a [routerLink]=\"[_baseUrl, parent.path]\">\n      <span [class]=\"parent.data.icon\"></span>&nbsp;&nbsp;{{ parent.data.title }}\n    </a>\n  </li>\n</ul>\n",
                encapsulation: core.ViewEncapsulation.None,
                changeDetection: core.ChangeDetectionStrategy.OnPush,
                host: {
                    'class': 'nt-nav-topbar'
                }
            })
        ], NtNavTopbarComponent);
        return NtNavTopbarComponent;
    }(NtNavController));

    var __decorate$4 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtNavModule = (function () {
        function NtNavModule() {
        }
        NtNavModule_1 = NtNavModule;
        NtNavModule.forRoot = function (config) {
            return {
                ngModule: NtNavModule_1,
                providers: [
                    { provide: NT_NAV_CONFIG, useValue: config }
                ]
            };
        };
        var NtNavModule_1;
        NtNavModule = NtNavModule_1 = __decorate$4([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    router.RouterModule,
                    overlay.OverlayModule,
                    overlay$1.NtOverlayModule,
                ],
                exports: [
                    NtNavSidebarComponent,
                    NtNavTopbarComponent,
                    NtNavBreadcrumbsComponent,
                ],
                declarations: [
                    NtNavSidebarComponent,
                    NtNavTopbarComponent,
                    NtNavBreadcrumbsComponent
                ],
                providers: [NtNavigationAdapter]
            })
        ], NtNavModule);
        return NtNavModule;
    }());

    exports.NT_NAV_CONFIG = NT_NAV_CONFIG;
    exports.NT_NAV_MENUS = NT_NAV_MENUS;
    exports.NtNavModule = NtNavModule;
    exports.NtNavSidebarComponent = NtNavSidebarComponent;
    exports.NtNavTopbarComponent = NtNavTopbarComponent;
    exports.NtNavigationAdapter = NtNavigationAdapter;
    exports.resolveTitle = resolveTitle;
    exports.ɵa = NtNavController;
    exports.ɵb = NtNavBreadcrumbsComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=navigation.umd.js.map
