(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/animations'), require('@angular/core'), require('@angular/forms'), require('@ng-tangram/components/core'), require('@angular/common'), require('@ng-tangram/components/autocomplete'), require('@ng-tangram/components/input')) :
    typeof define === 'function' && define.amd ? define('@ng-tangram/pro/search-input', ['exports', 'rxjs', 'rxjs/operators', '@angular/animations', '@angular/core', '@angular/forms', '@ng-tangram/components/core', '@angular/common', '@ng-tangram/components/autocomplete', '@ng-tangram/components/input'], factory) :
    (global = global || self, factory((global.nt = global.nt || {}, global.nt.pro = global.nt.pro || {}, global.nt.pro.searchInput = {}), global.rxjs, global.rxjs.operators, global.ng.animations, global.ng.core, global.ng.forms, global.core$1, global.ng.common, global.autocomplete, global.input));
}(this, (function (exports, rxjs, operators, animations, core, forms, core$1, common, autocomplete, input) { 'use strict';

    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtSearchInputComponent = (function () {
        function NtSearchInputComponent() {
            var _this = this;
            this._destory = new rxjs.Subject();
            this._keywordChange = new rxjs.Subject();
            this._placeholder = '';
            this._prekeyword = '';
            this._inputing = false;
            this._keywordControl = new forms.FormControl();
            this.search = rxjs.defer(function () {
                return _this._keywordChange.pipe(operators.distinctUntilChanged(), operators.takeUntil(_this._destory));
            });
            this.input = rxjs.defer(function () {
                return _this._keywordControl.valueChanges.pipe(operators.startWith(''), operators.takeUntil(_this._destory));
            });
        }
        Object.defineProperty(NtSearchInputComponent.prototype, "placeholder", {
            get: function () { return this._placeholder; },
            set: function (value) {
                this._placeholder = value;
            },
            enumerable: true,
            configurable: true
        });
        NtSearchInputComponent.prototype.onEnter = function (event) {
            this._keywordChange.next(this._keywordControl.value);
            this._prekeyword = this._keywordControl.value;
        };
        NtSearchInputComponent.prototype.onBlur = function () {
            this._inputing = false;
            this._keywordControl.setValue(this._prekeyword, { emitEvent: false });
        };
        NtSearchInputComponent.prototype.clearKeyword = function (event) {
            this._keywordControl.setValue('');
            this.onEnter(event);
            event.stopPropagation();
        };
        NtSearchInputComponent.prototype.onOptionSelected = function (change) {
            console.log(change);
            this._keywordChange.next(change.option.value);
            this._keywordControl.setValue(change.option.value, { emitEvent: false });
        };
        __decorate([
            core.Input()
        ], NtSearchInputComponent.prototype, "placeholder", null);
        __decorate([
            core.Output()
        ], NtSearchInputComponent.prototype, "search", void 0);
        __decorate([
            core.Output()
        ], NtSearchInputComponent.prototype, "input", void 0);
        NtSearchInputComponent = __decorate([
            core.Component({
                selector: 'nt-search-input',
                template: "<nt-input-group transparent=\"true\" ntAutocompleteOrigin #origin=\"ntAutocompleteOrigin\">\n  <nt-input-addon>\n    <span class=\"fas fa-search\"></span>\n  </nt-input-addon>\n  <input type=\"text\"\n    [placeholder]=\"placeholder\"\n    [formControl]=\"_keywordControl\"\n    [ntAutocomplete]=\"auto\"\n    [ntAutocompleteConnectedTo]=\"origin\"\n    (keyup.enter)=\"onEnter($event)\"\n    (blur)=\"onBlur()\"\n    (focus)=\"_inputing = true\">\n  <nt-input-addon class=\"nt-search-input-clear\"\n    [@fade]\n    (click)=\"clearKeyword($event)\"\n    *ngIf=\"!_inputing && _prekeyword\">\n    <span class=\"fas fa-times-circle\"></span>\n  </nt-input-addon>\n</nt-input-group>\n\n<nt-autocomplete #auto=\"ntAutocomplete\" (optionSelected)=\"onOptionSelected($event)\">\n  <ng-content select=\"nt-option\"></ng-content>\n</nt-autocomplete>\n",
                encapsulation: core.ViewEncapsulation.None,
                animations: [
                    animations.trigger('fade', [
                        animations.transition('void => *', core$1.fadeIn(.15)),
                        animations.transition('* => void', core$1.fadeOut(.15))
                    ])
                ],
                host: {
                    'class': 'nt-search-input'
                }
            })
        ], NtSearchInputComponent);
        return NtSearchInputComponent;
    }());

    var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var NtSearchInputModule = (function () {
        function NtSearchInputModule() {
        }
        NtSearchInputModule = __decorate$1([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.ReactiveFormsModule,
                    input.NtInputModule,
                    autocomplete.NtAutocompleteModule
                ],
                exports: [
                    NtSearchInputComponent,
                    input.NtInputModule,
                    autocomplete.NtAutocompleteModule
                ],
                declarations: [
                    NtSearchInputComponent
                ]
            })
        ], NtSearchInputModule);
        return NtSearchInputModule;
    }());

    exports.NtSearchInputComponent = NtSearchInputComponent;
    exports.NtSearchInputModule = NtSearchInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=searchInput.umd.js.map
