import { CommonModule } from '@angular/common';
import { EventEmitter, Input, Output, Component, TemplateRef, Directive, ViewContainerRef, ChangeDetectorRef, ViewChild, ContentChildren, ChangeDetectionStrategy, ViewEncapsulation, NgModule } from '@angular/core';
import { ActivatedRoute, Router, RouterModule } from '@angular/router';
import { NtLabelModule } from '@ng-tangram/components/label';
import { Subject } from 'rxjs';
import { delay, takeUntil } from 'rxjs/operators';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let NtQueryParamComponent = class NtQueryParamComponent {
    constructor() {
        this.remove = new EventEmitter();
    }
    emitRemoveEvent() {
        this.remove.emit(this);
    }
};
__decorate([
    Input()
], NtQueryParamComponent.prototype, "label", void 0);
__decorate([
    Output()
], NtQueryParamComponent.prototype, "remove", void 0);
NtQueryParamComponent = __decorate([
    Component({
        selector: 'nt-query-param',
        template: `
    <nt-label class="primary">
      {{label}}：
      <ng-content></ng-content>
      <span (click)="emitRemoveEvent()" class="fas fa-times" class="clear-icon"></span>
    </nt-label>
  `,
        host: {
            'class': 'nt-query-param'
        }
    })
], NtQueryParamComponent);

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let NtQueryParamDefDirective = class NtQueryParamDefDirective {
    constructor(template) {
        this.template = template;
    }
};
NtQueryParamDefDirective.ctorParameters = () => [
    { type: TemplateRef }
];
__decorate$1([
    Input('ntQueryParamDefKey')
], NtQueryParamDefDirective.prototype, "key", void 0);
NtQueryParamDefDirective = __decorate$1([
    Directive({
        selector: '[ntQueryParamDef]',
    })
], NtQueryParamDefDirective);

var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let NtQueryParamsOutletDirective = class NtQueryParamsOutletDirective {
    constructor(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
};
NtQueryParamsOutletDirective.ctorParameters = () => [
    { type: ViewContainerRef }
];
NtQueryParamsOutletDirective = __decorate$2([
    Directive({
        selector: '[ntQueryParamsOutlet]'
    })
], NtQueryParamsOutletDirective);

var __decorate$3 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let NtQueryParamsComponent = class NtQueryParamsComponent {
    constructor(viewContainerRef, route, router, _changeDetectorRef) {
        this.viewContainerRef = viewContainerRef;
        this.route = route;
        this.router = router;
        this._changeDetectorRef = _changeDetectorRef;
        this._destroy = new Subject();
    }
    ngAfterViewInit() {
        this.route.queryParams
            .pipe(delay(0), takeUntil(this._destroy))
            .subscribe(query => {
            this._clearViewContainer();
            this._attachmentQueryParamItems(query);
        });
        this.queryParamDefs.changes.subscribe(items => {
            this._clearViewContainer();
            console.log(items);
        });
    }
    ngOnDestroy() {
        this._destroy.next();
        this._destroy.complete();
    }
    clearAll() {
        this.router.navigate(['./'], { relativeTo: this.route });
    }
    _clearViewContainer() {
        this._outlet.viewContainerRef.clear();
    }
    _attachmentQueryParamItems(query) {
        const defs = this.queryParamDefs.toArray();
        const queryParamKeys = Object.keys(query);
        defs.forEach((def) => {
            if (queryParamKeys.includes(def.key)) {
                const context = { $implicit: query[def.key] };
                this._outlet.viewContainerRef.createEmbeddedView(def.template, context);
            }
        });
        this._changeDetectorRef.markForCheck();
    }
    _createQueryParamItemContext() {
    }
};
NtQueryParamsComponent.ctorParameters = () => [
    { type: ViewContainerRef },
    { type: ActivatedRoute },
    { type: Router },
    { type: ChangeDetectorRef }
];
__decorate$3([
    ViewChild(NtQueryParamsOutletDirective, { static: true })
], NtQueryParamsComponent.prototype, "_outlet", void 0);
__decorate$3([
    ContentChildren(NtQueryParamDefDirective, { descendants: true })
], NtQueryParamsComponent.prototype, "queryParamDefs", void 0);
NtQueryParamsComponent = __decorate$3([
    Component({
        selector: 'nt-query-params',
        template: "<ng-container *ntQueryParamsOutlet></ng-container>\n<div class=\"clear-all-icon\" (click)=\"clearAll()\">\u6E05\u9664</div>\n",
        changeDetection: ChangeDetectionStrategy.OnPush,
        encapsulation: ViewEncapsulation.None,
        host: {
            'class': 'nt-query-params'
        }
    })
], NtQueryParamsComponent);

var __decorate$4 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
let NtQueryParamsModule = class NtQueryParamsModule {
};
NtQueryParamsModule = __decorate$4([
    NgModule({
        imports: [
            CommonModule,
            RouterModule,
            NtLabelModule,
        ],
        declarations: [
            NtQueryParamsComponent,
            NtQueryParamDefDirective,
            NtQueryParamsOutletDirective,
            NtQueryParamComponent
        ],
        exports: [
            NtQueryParamDefDirective,
            NtQueryParamsOutletDirective,
            NtQueryParamsComponent,
            NtQueryParamComponent
        ]
    })
], NtQueryParamsModule);

export { NtQueryParamComponent, NtQueryParamDefDirective, NtQueryParamsComponent, NtQueryParamsModule, NtQueryParamsOutletDirective as ɵa };
//# sourceMappingURL=queryParams.js.map
