import { CommonModule } from '@angular/common';
import { EventEmitter, Input, Output, Component, TemplateRef, Directive, ViewContainerRef, ChangeDetectorRef, ViewChild, ContentChildren, ChangeDetectionStrategy, ViewEncapsulation, NgModule } from '@angular/core';
import { ActivatedRoute, Router, RouterModule } from '@angular/router';
import { NtLabelModule } from '@ng-tangram/components/label';
import { Subject } from 'rxjs';
import { delay, takeUntil } from 'rxjs/operators';

var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamComponent = (function () {
    function NtQueryParamComponent() {
        this.remove = new EventEmitter();
    }
    NtQueryParamComponent.prototype.emitRemoveEvent = function () {
        this.remove.emit(this);
    };
    __decorate([
        Input()
    ], NtQueryParamComponent.prototype, "label", void 0);
    __decorate([
        Output()
    ], NtQueryParamComponent.prototype, "remove", void 0);
    NtQueryParamComponent = __decorate([
        Component({
            selector: 'nt-query-param',
            template: "\n    <nt-label class=\"primary\">\n      {{label}}\uFF1A\n      <ng-content></ng-content>\n      <span (click)=\"emitRemoveEvent()\" class=\"fas fa-times\" class=\"clear-icon\"></span>\n    </nt-label>\n  ",
            host: {
                'class': 'nt-query-param'
            }
        })
    ], NtQueryParamComponent);
    return NtQueryParamComponent;
}());

var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamDefDirective = (function () {
    function NtQueryParamDefDirective(template) {
        this.template = template;
    }
    NtQueryParamDefDirective.ctorParameters = function () { return [
        { type: TemplateRef }
    ]; };
    __decorate$1([
        Input('ntQueryParamDefKey')
    ], NtQueryParamDefDirective.prototype, "key", void 0);
    NtQueryParamDefDirective = __decorate$1([
        Directive({
            selector: '[ntQueryParamDef]',
        })
    ], NtQueryParamDefDirective);
    return NtQueryParamDefDirective;
}());

var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamsOutletDirective = (function () {
    function NtQueryParamsOutletDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    NtQueryParamsOutletDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    NtQueryParamsOutletDirective = __decorate$2([
        Directive({
            selector: '[ntQueryParamsOutlet]'
        })
    ], NtQueryParamsOutletDirective);
    return NtQueryParamsOutletDirective;
}());

var __decorate$3 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamsComponent = (function () {
    function NtQueryParamsComponent(viewContainerRef, route, router, _changeDetectorRef) {
        this.viewContainerRef = viewContainerRef;
        this.route = route;
        this.router = router;
        this._changeDetectorRef = _changeDetectorRef;
        this._destroy = new Subject();
    }
    NtQueryParamsComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.route.queryParams
            .pipe(delay(0), takeUntil(this._destroy))
            .subscribe(function (query) {
            _this._clearViewContainer();
            _this._attachmentQueryParamItems(query);
        });
        this.queryParamDefs.changes.subscribe(function (items) {
            _this._clearViewContainer();
            console.log(items);
        });
    };
    NtQueryParamsComponent.prototype.ngOnDestroy = function () {
        this._destroy.next();
        this._destroy.complete();
    };
    NtQueryParamsComponent.prototype.clearAll = function () {
        this.router.navigate(['./'], { relativeTo: this.route });
    };
    NtQueryParamsComponent.prototype._clearViewContainer = function () {
        this._outlet.viewContainerRef.clear();
    };
    NtQueryParamsComponent.prototype._attachmentQueryParamItems = function (query) {
        var _this = this;
        var defs = this.queryParamDefs.toArray();
        var queryParamKeys = Object.keys(query);
        defs.forEach(function (def) {
            if (queryParamKeys.includes(def.key)) {
                var context = { $implicit: query[def.key] };
                _this._outlet.viewContainerRef.createEmbeddedView(def.template, context);
            }
        });
        this._changeDetectorRef.markForCheck();
    };
    NtQueryParamsComponent.prototype._createQueryParamItemContext = function () {
    };
    NtQueryParamsComponent.ctorParameters = function () { return [
        { type: ViewContainerRef },
        { type: ActivatedRoute },
        { type: Router },
        { type: ChangeDetectorRef }
    ]; };
    __decorate$3([
        ViewChild(NtQueryParamsOutletDirective, { static: true })
    ], NtQueryParamsComponent.prototype, "_outlet", void 0);
    __decorate$3([
        ContentChildren(NtQueryParamDefDirective, { descendants: true })
    ], NtQueryParamsComponent.prototype, "queryParamDefs", void 0);
    NtQueryParamsComponent = __decorate$3([
        Component({
            selector: 'nt-query-params',
            template: "<ng-container *ntQueryParamsOutlet></ng-container>\n<div class=\"clear-all-icon\" (click)=\"clearAll()\">\u6E05\u9664</div>\n",
            changeDetection: ChangeDetectionStrategy.OnPush,
            encapsulation: ViewEncapsulation.None,
            host: {
                'class': 'nt-query-params'
            }
        })
    ], NtQueryParamsComponent);
    return NtQueryParamsComponent;
}());

var __decorate$4 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var NtQueryParamsModule = (function () {
    function NtQueryParamsModule() {
    }
    NtQueryParamsModule = __decorate$4([
        NgModule({
            imports: [
                CommonModule,
                RouterModule,
                NtLabelModule,
            ],
            declarations: [
                NtQueryParamsComponent,
                NtQueryParamDefDirective,
                NtQueryParamsOutletDirective,
                NtQueryParamComponent
            ],
            exports: [
                NtQueryParamDefDirective,
                NtQueryParamsOutletDirective,
                NtQueryParamsComponent,
                NtQueryParamComponent
            ]
        })
    ], NtQueryParamsModule);
    return NtQueryParamsModule;
}());

export { NtQueryParamComponent, NtQueryParamDefDirective, NtQueryParamsComponent, NtQueryParamsModule, NtQueryParamsOutletDirective as ɵa };
//# sourceMappingURL=queryParams.js.map
