"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular-devkit/core");
const schematics_1 = require("@angular-devkit/schematics");
const parse_name_1 = require("@schematics/angular/utility/parse-name");
const project_1 = require("@schematics/angular/utility/project");
const angular_config_1 = require("../../utils/angular-config");
const get_project_1 = require("../../utils/get-project");
function default_1(options) {
    return (tree, context) => {
        const workspace = angular_config_1.getWorkspace(tree);
        const project = get_project_1.getProjectFromWorkspace(workspace, options.project);
        if (options.path === undefined) {
            // TODO(jelbourn): figure out if the need for this `as any` is a bug due to two different
            // incompatible `WorkspaceProject` classes in @angular-devkit
            options.path = project_1.buildDefaultPath(project);
        }
        const parsedPath = parse_name_1.parseName(options.path, options.name);
        options.name = parsedPath.name;
        options.path = `${parsedPath.path}/${options.name}`;
        const templateSource = schematics_1.apply(schematics_1.url('./files'), [
            schematics_1.applyTemplates(Object.assign({ classify: core_1.strings.classify, dasherize: core_1.strings.dasherize, camelize: core_1.strings.camelize }, options)),
            schematics_1.move(null, parsedPath.path),
        ]);
        return schematics_1.chain([
            schematics_1.mergeWith(templateSource)
        ])(tree, context);
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map