"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schematics_1 = require("@angular-devkit/schematics");
const forceOptions = {
    routing: true,
    skipTests: true,
    style: 'scss',
};
function default_1(options) {
    return () => {
        if (!options.name) {
            throw new schematics_1.SchematicsException(`Invalid options, "name" is required.`);
        }
        const ngAddDefaultOptions = {
            name: options.name,
            skipInstall: true,
        };
        if (!options.directory) {
            options.directory = options.name;
        }
        return schematics_1.chain([
            schematics_1.externalSchematic('@schematics/angular', 'ng-new', Object.assign(Object.assign({}, options), forceOptions)),
            schematics_1.schematic('ng-add', ngAddDefaultOptions, { scope: options.name }),
            schematics_1.schematic('ng-new-setup-project', options, { scope: options.directory }),
        ]);
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map