"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular-devkit/core");
const schematics_1 = require("@angular-devkit/schematics");
const interface_1 = require("@angular-devkit/schematics/src/tree/interface");
const package_config_1 = require("../utils/package-config");
function addUniversalPackageToPackageJson() {
    return (tree) => {
        [
            '@nguniversal/common',
            '@nguniversal/express-engine',
            '@gorniv/ngx-universal'
        ].forEach(name => {
            package_config_1.addPackageToDependenciesNode(tree, name, 'latest');
        });
        return tree;
    };
}
function default_1(options) {
    return (tree, context) => {
        // const workspace = getWorkspace(tree);
        core_1.strings.camelize;
        const rootTemplateSource = schematics_1.apply(schematics_1.url(`./files/${options.template}`), [
            schematics_1.applyTemplates(Object.assign({ classify: core_1.strings.classify, dasherize: core_1.strings.dasherize, camelize: core_1.strings.camelize }, options)),
        ]);
        const mergedRules = [schematics_1.mergeWith(rootTemplateSource, interface_1.MergeStrategy.Overwrite)];
        if (options.ssr) {
            mergedRules.push(addUniversalPackageToPackageJson());
        }
        return schematics_1.chain(mergedRules)(tree, context);
    };
}
exports.default = default_1;
//# sourceMappingURL=setup-project.js.map