/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
import { Tree } from '@angular-devkit/schematics';
/** Adds a package to the package.json in the given tree. */
export declare function addPackageToPackageJson(tree: Tree, type: string, pkg: string, version: string): Tree;
export declare function addPackageToDependenciesNode(tree: Tree, pkg: string, version: string): Tree;
export declare function addPackageToDevDependenciesNode(tree: Tree, pkg: string, version: string): Tree;
/** Gets the version of the specified package by looking at the package.json in the given tree. */
export declare function getPackageVersionFromPackageJson(tree: Tree, name: string): string | null;
